/*
 * @DEC_COPYRIGHT@
 */
/*
 * HISTORY
 * $Log: in.h,v $
 * Revision 1.10  1997/02/04  01:57:57  mccann
 * RIPng + multilink checkin, sct 19970203-mccann-ripng_multilink.txt
 *
 * Revision 1.9  1996/05/31  20:45:36  mccann
 * bsd-api-05 checkin
 *
 * Revision 1.8  1996/05/26  20:23:36  thomas
 * Add IPPROTO_IPV4 for IPv4 in IPv4
 *
 * Revision 1.7  1996/05/10  21:31:19  mccann
 * PMTU Discovery and IPv6 Forwarding checkin
 *
 * Revision 1.6  1996/04/05  20:40:27  root
 * add IP_DONT_FRAGMENT
 *
 * Revision 1.5  1996/01/19  18:03:02  thomas
 * minor cleanup
 *
 * Revision 1.4  1995/09/11  18:24:04  thomas
 * include in6.h if !kernel
 *
 * Revision 1.3  1995/09/01  23:45:25  thomas
 * IPv4 interface
 * moved ipv6 to separate file
 *
 * Revision 1.2  1995/08/29  15:13:05  thomas
 * add s6_addr for sanity's sake
 *
 * Revision 1.1  1995/08/24  19:28:27  root
 * Initial revision
 *
 * Revision 4.3.10.7  1994/05/12  18:01:23  Thomas_Peterson
 * 	Removed local decls of ntohs(), htons(), ntohl(), htonl() and included
 * 	<machine/endian.h> which has these same decls already.
 * 	[1994/04/25  16:45:13  Thomas_Peterson]
 *
 * Revision 4.3.10.6  1994/02/23  15:51:20  Gerry_Feldman
 * 	 Added space before the __() macros.
 * 	[1994/02/23  15:49:56  Gerry_Feldman]
 * 
 * Revision 4.3.10.4  1994/02/22  21:22:17  Gerry_Feldman
 * 	Added definitions for ntohs, ntohl, htons, and htonl
 * 	[1994/02/22  21:06:38  Gerry_Feldman]
 * 
 * Revision 4.3.10.3  1993/11/09  19:42:07  Geraldine_Harter
 * 	Merge in Sterling BL7:
 * 	Revision 4.3.6.3  1993/10/04  21:14:07  Heather_Gray
 * 	Revert to old option defs for binary compatibility.
 * 	[1993/10/04  01:36:09  Heather_Gray]
 * 
 * Revision 4.3.10.2  1993/09/28  19:06:17  Geraldine_Harter
 * 	Merge in Sterling BL6.
 * 	 Revision 4.3.6.2  1993/05/16  21:16:45  Heather_Gray
 * 		Changed sockopt values to be consistent with BSD.
 * 		[1993/05/12  17:58:44  Heather_Gray]
 * 
 * 		Correct comment re: mbuf.
 * 		[1993/05/02  22:06:28  Heather_Gray]
 * 
 * 		Add IGMP protocol and support for class D handling.
 * 		Add IP Multicast group definitions.
 * 		Add IP Multicast socket option definitions and
 * 		struct mreq.
 * 		[1993/04/12  00:46:24  Heather_Gray]
 * 	[1993/09/28  15:50:40  Geraldine_Harter]
 * 
 * Revision 4.3.3.3  1992/04/15  14:08:43  Geraldine_Harter
 * 	Merged in Silver BL6
 * 	Revision 4.3.4.2  92/04/13  18:30:55  devbld_gsf
 * 	First AG_BL6 version.  Moved from Ag baselevel delivery tree.
 * 	Revision 4.2.2.2  92/03/27  15:05:59  Craig_Horman
 * 	Added C++ Support (redefined ip_opts and included sys/types.h)
 * 	[92/03/10  14:30:56  Craig_Horman]
 * 
 * Revision 4.3.3.2  92/04/06  14:28:59  Geraldine_Harter
 * 	Removed 'ifdef __alpha' from code that is not alpha-dependent.  Kept the
 * 	version of the code that correctly declares a net-type to be 'u_int' instead
 * 	of 'u_long'
 * 	[92/04/06  14:25:36  Geraldine_Harter]
 * 
 * Revision 4.3  92/01/15  02:02:59  devbld_gsf
 * 	Baselevel alpha_bl002
 * 
 * Revision 4.2.2.2  91/12/07  16:11:14  Ray_Lanza
 * 	Merged tin-based ALPHA version
 * 	[91/12/07  16:06:07  Ray_Lanza]
 * 
 * Revision 4.2  91/09/19  22:46:53  devbld
 * 	Adding ODE Headers
 * 
 * $EndLog$
 */
/*
 *	@(#)$RCSfile: in.h,v $ $Revision: 1.10 $ (DEC) $Date: 1997/02/04 01:57:57 $
 */
/*
 */
/*
 * (c) Copyright 1990, 1991, OPEN SOFTWARE FOUNDATION, INC.
 * ALL RIGHTS RESERVED
 */
/*
 * OSF/1 Release 1.0.1
 */
/*
 * Copyright (C) 1988,1989 Encore Computer Corporation.  All Rights Reserved
 *
 * Property of Encore Computer Corporation.
 * This software is made available solely pursuant to the terms of
 * a software license agreement which governs its use. Unauthorized
 * duplication, distribution or sale are strictly prohibited.
 *
 */
/*
 * Copyright (c) 1982, 1986 Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms are permitted provided
 * that: (1) source distributions retain this entire copyright notice and
 * comment, and (2) distributions including binaries display the following
 * acknowledgement:  ``This product includes software developed by the
 * University of California, Berkeley and its contributors'' in the
 * documentation or other materials provided with the distribution and in
 * all advertising materials mentioning features or use of this software.
 * Neither the name of the University nor the names of its contributors may
 * be used to endorse or promote products derived from this software without
 * specific prior written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 *
 *	Base:	in.h	7.8 (Berkeley) 9/13/89
 *	Merged:	in.h	7.10 (Berkeley) 6/28/90
 */

#ifndef	_NETINET_IN_H_
#define	_NETINET_IN_H_

#include <sys/types.h>

/*
 * Constants and structures defined by the internet system,
 * Per RFC 790, September 1981.
 */

/*
 * Protocols
 */
#define	IPPROTO_IP		0		/* dummy for IP */
#define	IPPROTO_ICMP		1		/* control message protocol */
#define IPPROTO_IGMP		2		/* group mgmt protocol */
#define	IPPROTO_GGP		3		/* gateway^2 (deprecated) */
#define	IPPROTO_IPV4		4		/* IPv4 (tunneled) */
#define	IPPROTO_TCP		6		/* tcp */
#define	IPPROTO_EGP		8		/* exterior gateway protocol */
#define	IPPROTO_PUP		12		/* pup */
#define	IPPROTO_UDP		17		/* user datagram protocol */
#define	IPPROTO_IDP		22		/* xns idp */
#define	IPPROTO_TP		29 		/* tp-4 w/ class negotiation */
#define	IPPROTO_EON		80		/* ISO cnlp */

#define	IPPROTO_RAW		255		/* raw IP packet */
#define	IPPROTO_MAX		256

/*
 * Local port number conventions:
 * Ports < IPPORT_RESERVED are reserved for
 * privileged processes (e.g. root).
 * Ports > IPPORT_USERRESERVED are reserved
 * for servers, not necessarily privileged.
 */
#define	IPPORT_RESERVED		1024
#define	IPPORT_USERRESERVED	5000

/* From Sun 4.1 sources, needed for SUN rpc */
#define    IPPORT_TIMESERVER       37

/*
 * Internet address (a structure for historical reasons)
 */
struct in_addr {
	u_int  s_addr;
};

/*
 * Maximum length of IPv4 address as text string.
 */

#define INET_ADDRSTRLEN         16

/*
 * Definitions of bits in internet address integers.
 * On subnets, the decomposition of addresses to host and net parts
 * is done according to subnet mask, not the masks here.
 */
#define	IN_CLASSA(i)		(((int)(i) & 0x80000000) == 0)
#define	IN_CLASSA_NET		0xff000000
#define	IN_CLASSA_NSHIFT	24
#define	IN_CLASSA_HOST		0x00ffffff
#define	IN_CLASSA_MAX		128

#define	IN_CLASSB(i)		(((int)(i) & 0xc0000000) == 0x80000000)
#define	IN_CLASSB_NET		0xffff0000
#define	IN_CLASSB_NSHIFT	16
#define	IN_CLASSB_HOST		0x0000ffff
#define	IN_CLASSB_MAX		65536

#define	IN_CLASSC(i)		(((int)(i) & 0xe0000000) == 0xc0000000)
#define	IN_CLASSC_NET		0xffffff00
#define	IN_CLASSC_NSHIFT	8
#define	IN_CLASSC_HOST		0x000000ff

#define	IN_CLASSD(i)		(((int)(i) & 0xf0000000) == 0xe0000000)
#define IN_CLASSD_NET		0xf0000000	/* These ones aren't really */
#define IN_CLASSD_NSHIFT	28		/* net and host fields, but */
#define IN_CLASSD_HOST		0x0fffffff	/* routing needn't know.  */
#define	IN_MULTICAST(i)		IN_CLASSD(i)

#define	IN_EXPERIMENTAL(i)	(((int)(i) & 0xe0000000) == 0xe0000000)
#define	IN_BADCLASS(i)		(((int)(i) & 0xf0000000) == 0xf0000000)

#define	INADDR_ANY		(u_int)0x00000000
#define	INADDR_BROADCAST	(u_int)0xffffffff	/* must be masked */
#define INADDR_LOOPBACK         (u_int)0x7F000001

#define INADDR_UNSPEC_GROUP	(u_int)0xe0000000	/* 224.0.0.0   */
#define INADDR_ALLHOSTS_GROUP	(u_int)0xe0000001	/* 224.0.0.1   */
#define INADDR_MAX_LOCAL_GROUP	(u_int)0xe00000ff	/* 224.0.0.255 */

#ifndef _KERNEL
#define	INADDR_NONE		0xffffffff		/* -1 return */
#endif

#define	IN_LOOPBACKNET		127			/* official! */

/*
 * Socket address, internet style.
 */
#if	defined(_SOCKADDR_LEN) || defined(_KERNEL)
struct sockaddr_in {
	u_char	sin_len;
	u_char	sin_family;
	u_short	sin_port;
	struct	in_addr sin_addr;
	char	sin_zero[8];
};
#else
struct sockaddr_in {
	u_short	sin_family;
	u_short	sin_port;
	struct	in_addr sin_addr;
	char	sin_zero[8];
};
#endif

/*
 * Structure used to describe IP options.
 * Used to store options internally, to pass them to a process,
 * or to restore options retrieved earlier.
 * The ip_dst is used for the first-hop gateway when using a source route
 * (this gets put into the header proper).
 */
struct ip_opts {
	struct	in_addr ip_dst;		/* first hop, 0 w/o src rt */
#if defined(__cplusplus)
	char    Ip_opts[40];            /* cannot have same name as class */
#else
	char	ip_opts[40];		/* actually variable in size */
#endif
};

/*
 * Options for use with [gs]etsockopt at the IP level.
 * First word of comment is data type; bool is stored in int.
 */
#define	IP_OPTIONS	1	/* buf/ip_opts; set/get IP per-packet options */
#define	IP_HDRINCL	2	/* int; header is included with data (raw) */
#define	IP_TOS		3	/* int; IP type of service and precedence */
#define	IP_TTL		4	/* int; IP time to live */
#define	IP_RECVOPTS	5	/* bool; receive all IP options w/datagram */
#define	IP_RECVRETOPTS	6	/* bool; receive IP options for response */
#define	IP_RECVDSTADDR	7	/* bool; receive IP dst addr w/datagram */
#define	IP_RETOPTS	8	/* ip_opts; set/get IP per-packet options */
#define IP_MULTICAST_IF	   9	/* in_addr; IP multicast interface */
#define IP_MULTICAST_TTL   10	/* u_char; IP multicast timetolive */
#define IP_MULTICAST_LOOP  11	/* u_char; IP multicast loopback */
#define IP_ADD_MEMBERSHIP  12	/* ip_mreq; add  an IP group membership */
#define IP_DROP_MEMBERSHIP 13	/* ip_mreq; drop an IP group membership */
/*	IP_FLOWLABEL	   14	   defined in in6.h */
/*	IP_RXHDR	   15	   defined in in6.h */
#define IP_DONT_FRAGMENT   16	/* bool; don't fragment, return error instead */
#define IP_PMTU_DISCOVERY  17	/* bool; participate in path mtu discovery */
#define IP_FRAG_TO_PMTU    18	/* bool; fragment to path mtu size */
#define IP_TXINTERFACE	   19	/* u_int; xmit interface index (experimental) */

#define IP_DEFAULT_MULTICAST_TTL   1	/* normally limit m'casts to 1 hop  */
#define IP_DEFAULT_MULTICAST_LOOP  1	/* normally hear sends if a member  */
#define IP_MAX_MEMBERSHIPS	   20	/* per socket */


/*
 * Argument structure for IP_ADD_MEMBERSHIP and IP_DROP_MEMBERSHIP.
 */
struct ip_mreq {
	struct in_addr	imr_multiaddr;	/* IP multicast address of group */
	struct in_addr	imr_interface;	/* local IP address of interface */
};

/*
 * Protocol specific route flags
 */

#define	RTF_PMTU	 RTF_PROTO4	/* rmx_mtu set by pmtu discovery */
#define	RTF_NOPMTUDISC	 RTF_PROTO5	/* pmtu discovery disabled */
#define	RTF_NOFRAGTOPMTU RTF_PROTO6     /* fragment to pmtu size disabled */
#define	RTF_LOOPBACK	 RTF_PROTO7     /* send packets over loopback device */

#if defined (_OSF_SOURCE)
/* included to get decls for ntohs, htons, ntohl, htonl */
#include <machine/endian.h>
#endif

#if defined(INET6) || !defined(KERNEL)
#include <netinet/in6.h>
#endif

#ifdef _KERNEL
extern	struct domain inetdomain;
extern	CONST struct protosw inetsw[];
extern	int inetprintfs;
extern	int ipgateway, ipforwarding;
#endif
#endif





